(require 'generic)
(require 'font-lock)

;; (defvar kiltera-font-lock-constant-face		'kiltera-font-lock-constant-face
;;  "Face name to use for constant and label names.")

(define-generic-mode 'kiltera-mode
  '("#")
  '("after" "and" "async" "at" "channel" "channels" "do" "else" "false" "for" "function" "from"
    "if" "import" "in" "interrupt" "let" "main" "match" "module" "nil" "not" "or" "par" "print"
    "process" "receive" "send" "seq" "sync" "then" "to" "timeout" "true" "unit" "wait" "with") 
  '(("zip" . font-lock-builtin-face)
    ("len" . font-lock-builtin-face)
    ("range" . font-lock-builtin-face)
    ("random" . font-builtin-type-face)
    ("->" . font-lock-type-face)
    ("|" . font-lock-type-face)
    ("(" . font-lock-builtin-face)
    (")" . font-lock-builtin-face)
    ("[" . font-lock-builtin-face)
    ("]" . font-lock-builtin-face)
    ("," . font-lock-builtin-face)
    (" [0-9]+" . 'devs-font-lock-constant-face)
    ("process \\([A-Za-z][A-Za-z0-9]*\\)[[A-Za-z0-9, _]*]" 1 font-lock-function-name-face)
   )
  '("\\.klt$")
  nil
  "kiltera mode")

(defface kiltera-font-lock-constant-face
   '((((type tty) (class color)) (:foreground "bluegreen" :weight light))
     (((class grayscale) (background light)) (:foreground "LightGray" :bold t))
     (((class grayscale) (background dark)) (:foreground "DimGray" :bold t))
     (((class color) (background light)) (:foreground "forest green"))
     (((class color) (background dark)) (:foreground "pale green"))
     (t (:bold t)))
   "Font Lock mode face used to highlight builtins."
   :group 'font-lock-highlighting-faces)

