"""
Project: kiltera 
Module: builtins
Author: Ernesto Posse
Created on: Aug 31, 2006
Last modified: Jan 22, 2007

Description:
  This implements primitive functions supported by kiltera.
"""

from values import BuiltInFunction
from posse_tools.utils import fit
#~ import itertools

def setup_built_ins():
    import random
    functions = \
        {
            'range':    BuiltInFunction(range),
            'len':      BuiltInFunction(tuple_length),
            'zip':      BuiltInFunction(zip),
            'random':   BuiltInFunction(random.random),
            'head':     BuiltInFunction(head),
            'tail':     BuiltInFunction(tail),
            'append':   BuiltInFunction(append),
            'prepend':  BuiltInFunction(prepend),
            'concat':   BuiltInFunction(concat),
            'fit':      BuiltInFunction(fit)
        }
    return functions


def tuple_length(tpl_generator):
    return len(list(tpl_generator))

def head(tpl_generator):
    return list(tpl_generator)[0]

def tail(tpl_generator):
    return list(tpl_generator)[1:]

def append(tpl_generator, value):
    return list(tpl_generator) + [value]

def prepend(value, tpl_generator):
    return [value] + list(tpl_generator)

def concat(tpl1, tpl2):
    return list(tpl1) + list(tpl2)

