from threading import currentThread

class RuntimeException(Exception):
    
    def __init__(self, term=None, msg=None):
        self.msg = msg
        self.thread = str(currentThread())
        self.term = term
        self.loc = 'main'
        self.pos = (0,0,0)
        self.line = 0
        self.start_col = 0
        self.construct = '-'
        if term is not None:
            self.construct = term.__class__.__name__
            self.loc = '.'.join([p.name for p in term.get_full_location()])
            self.line, self.start_col, self.end_col = term.pos
            self.pos = term.pos
            
    def __str__(self):
        return ("kiltera run-time exception: \n" \
            +    "  process: %s\n" \
            +    "  line: %d  column: %d\n" \
            +    "  construct: %s\n" \
            +    "  thread: %s\n" \
            +    "  description: %s\n") \
            % (self.loc, self.line, self.start_col, self.construct, self.thread, self.msg)


class StopThread(Exception):
    
    def __init__(self):
        self.thread = repr(currentThread())
    
    def __str__(self):
        return "thread stop: %s" % self.thread

class SimulatorException(Exception):
    
    def __init__(self, msg):
        self.msg = msg
    
    def __str__(self):
        return "simulator exception: %s" % self.msg

